﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ChromeStarter.Models
{
    public class ProfilePlanCollection : INotifyPropertyChanged
    {
        private ObservableCollection<ProfilePlan> _profilePlans;

        public event PropertyChangedEventHandler PropertyChanged;

        public ProfilePlanCollection()
        {
            _profilePlans = new ObservableCollection<ProfilePlan>();
        }

        public ObservableCollection<ProfilePlan> ProfilePlans
        {
            get { return _profilePlans; }
            set
            {
                _profilePlans = value;
                OnPropertyChanged(nameof(this.ProfilePlans));
            }
        }

        protected virtual void OnPropertyChanged(string propertyName = null)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public List<string> GetCommandParameter()
        {
            List<string> parameters = new List<string>();
            foreach (ProfilePlan plan in _profilePlans)
            {
                parameters.Add($"--profile-directory=\"{plan.Name}\" {plan.StartPage}");
            }

            return parameters;
        }
    }

    public class ProfilePlan
    {
        public string Name { get; set; }
        public string StartPage { get; set; }
    }
}
